//-----------------------------------------------------------------------------
// ڂtB^
//-----------------------------------------------------------------------------

// O[oϐ
float blurMapW;
float blurMapH;
texture blurMap;



// Tv
sampler2D blurSampler {
	Texture = <blurMap>;
	AddressU = Clamp;
	AddressV = Clamp;
	MagFilter = Linear;
	MinFilter = Linear;
	MipFilter = Linear;
};



struct VS_IN_Blur{
	float4	vPos	: POSITION;
	float2	vTex	: TEXCOORD0;
};

struct VS_OUT_Blur{
	float4	vPos	: POSITION;
	float2	vTex	: TEXCOORD0;
};



// _VF[_
VS_OUT_Blur Blur_VS( VS_IN_Blur In )
{
	VS_OUT_Blur Out;
	Out.vPos = In.vPos;
	Out.vTex = In.vTex;
	return Out;
}



// sNZVF[_
// ڂ Rs[p
float4 NoBlur_PS( VS_OUT_Blur In ) : COLOR
{
	return tex2D( blurSampler, In.vTex );
}

// P3x3̂ڂ
float4 Blur_PS( VS_OUT_Blur In ) : COLOR
{
	float offsetX = 1.0f / blurMapW;
	float offsetY = 1.0f / blurMapH;
	float4 col;
	col  = tex2D( blurSampler, In.vTex );											// 5
	col += tex2D( blurSampler, In.vTex + float2( -offsetX,     0.0f ) );			// 4
	col += tex2D( blurSampler, In.vTex + float2(  offsetX,     0.0f ) );			// 6
	col += tex2D( blurSampler, In.vTex + float2(     0.0f, -offsetY ) );			// 8
	col += tex2D( blurSampler, In.vTex + float2(     0.0f,  offsetY ) );			// 2
	col += tex2D( blurSampler, In.vTex + float2( -offsetX, -offsetY ) );			// 7
	col += tex2D( blurSampler, In.vTex + float2(  offsetX, -offsetY ) );			// 9
	col += tex2D( blurSampler, In.vTex + float2( -offsetX,  offsetY ) );			// 1
	col += tex2D( blurSampler, In.vTex + float2(  offsetX,  offsetY ) );			// 3
	col /= 9.0f;
	return col;
}


// KEXtB^ڂ
float4 Gauss5X_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapW;
	col  = 0.006646f * ( tex2D( blurSampler, In.vTex + float2( -offset*2, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*2, 0.0f ) ) );
	col += 0.194223f * ( tex2D( blurSampler, In.vTex + float2( -offset*1, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*1, 0.0f ) ) );
	col += 0.598263f * tex2D( blurSampler, In.vTex );
	return col;
}
float4 Gauss5Y_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapH;
	col  = 0.006646f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*2 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*2 ) ) );
	col += 0.194223f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*1 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*1 ) ) );
	col += 0.598263f * tex2D( blurSampler, In.vTex );
	return col;
}


float4 Gauss7X_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapW;
	col  = 0.015625f * ( tex2D( blurSampler, In.vTex + float2( -offset*3, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*3, 0.0f ) ) );
	col += 0.093750f * ( tex2D( blurSampler, In.vTex + float2( -offset*2, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*2, 0.0f ) ) );
	col += 0.234375f * ( tex2D( blurSampler, In.vTex + float2( -offset*1, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*1, 0.0f ) ) );
	col += 0.312500f * tex2D( blurSampler, In.vTex );
	return col;
}
float4 Gauss7Y_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapH;
	col  = 0.015625f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*3 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*3 ) ) );
	col += 0.093750f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*2 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*2 ) ) );
	col += 0.234375f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*1 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*1 ) ) );
	col += 0.312500f * tex2D( blurSampler, In.vTex );
	return col;
}


float4 Gauss9X_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapW;
	col  = 0.003326f * ( tex2D( blurSampler, In.vTex + float2( -offset*4, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*4, 0.0f ) ) );
	col += 0.023818f * ( tex2D( blurSampler, In.vTex + float2( -offset*3, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*3, 0.0f ) ) );
	col += 0.097192f * ( tex2D( blurSampler, In.vTex + float2( -offset*2, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*2, 0.0f ) ) );
	col += 0.225978f * ( tex2D( blurSampler, In.vTex + float2( -offset*1, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*1, 0.0f ) ) );
	col += 0.299373f * tex2D( blurSampler, In.vTex );
	return col;
}
float4 Gauss9Y_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapH;
	col  = 0.003326f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*4 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*4 ) ) );
	col += 0.023818f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*3 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*3 ) ) );
	col += 0.097192f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*2 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*2 ) ) );
	col += 0.225978f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*1 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*1 ) ) );
	col += 0.299373f * tex2D( blurSampler, In.vTex );
	return col;
}


float4 Gauss11X_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapW;
	col  = 0.002661f * ( tex2D( blurSampler, In.vTex + float2( -offset*5, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*5, 0.0f ) ) );
	col += 0.013447f * ( tex2D( blurSampler, In.vTex + float2( -offset*4, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*4, 0.0f ) ) );
	col += 0.047408f * ( tex2D( blurSampler, In.vTex + float2( -offset*3, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*3, 0.0f ) ) );
	col += 0.116606f * ( tex2D( blurSampler, In.vTex + float2( -offset*2, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*2, 0.0f ) ) );
	col += 0.200097f * ( tex2D( blurSampler, In.vTex + float2( -offset*1, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*1, 0.0f ) ) );
	col += 0.239560f * tex2D( blurSampler, In.vTex );
	return col;
}
float4 Gauss11Y_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapH;
	col  = 0.002661f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*5 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*5 ) ) );
	col += 0.013447f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*4 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*4 ) ) );
	col += 0.047408f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*3 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*3 ) ) );
	col += 0.116606f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*2 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*2 ) ) );
	col += 0.200097f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*1 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*1 ) ) );
	col += 0.239560f * tex2D( blurSampler, In.vTex );
	return col;
}


float4 Gauss15X_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapW;
	col  = 0.001902f * ( tex2D( blurSampler, In.vTex + float2( -offset*7, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*7, 0.0f ) ) );
	col += 0.006275f * ( tex2D( blurSampler, In.vTex + float2( -offset*6, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*6, 0.0f ) ) );
	col += 0.017232f * ( tex2D( blurSampler, In.vTex + float2( -offset*5, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*5, 0.0f ) ) );
	col += 0.039383f * ( tex2D( blurSampler, In.vTex + float2( -offset*4, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*4, 0.0f ) ) );
	col += 0.074903f * ( tex2D( blurSampler, In.vTex + float2( -offset*3, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*3, 0.0f ) ) );
	col += 0.118555f * ( tex2D( blurSampler, In.vTex + float2( -offset*2, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*2, 0.0f ) ) );
	col += 0.156160f * ( tex2D( blurSampler, In.vTex + float2( -offset*1, 0.0f ) ) + tex2D( blurSampler, In.vTex + float2(  offset*1, 0.0f ) ) );
	col += 0.171180f * tex2D( blurSampler, In.vTex );
	return col;
}
float4 Gauss15Y_PS( VS_OUT_Blur In ) : COLOR
{
	float4 col;
	float offset = 1.0f / blurMapH;
	col  = 0.001902f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*7 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*7 ) ) );
	col += 0.006275f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*6 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*6 ) ) );
	col += 0.017232f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*5 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*5 ) ) );
	col += 0.039383f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*4 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*4 ) ) );
	col += 0.074903f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*3 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*3 ) ) );
	col += 0.118555f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*2 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*2 ) ) );
	col += 0.156160f * ( tex2D( blurSampler, In.vTex + float2( 0.0f, -offset*1 ) ) + tex2D( blurSampler, In.vTex + float2( 0.0f,  offset*1 ) ) );
	col += 0.171180f * tex2D( blurSampler, In.vTex );
	return col;
}
// ΂ 15 Ƃڂ



// eNjbN
technique NoBlur
{
	pass P0
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 NoBlur_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
}

technique Blur
{
	pass P0
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Blur_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
}

technique GaussBlur5
{
	pass P0
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss5X_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss5Y_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
}

technique GaussBlur7
{
	pass P0
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss7X_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss7Y_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
}

technique GaussBlur9
{
	pass P0
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss9X_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss9Y_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
}

technique GaussBlur11
{
	pass P0
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss11X_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss11Y_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
}

technique GaussBlur15
{
	pass P0
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss15X_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
	pass P1
	{
		VertexShader = compile vs_2_0 Blur_VS();
		PixelShader = compile ps_2_0 Gauss15Y_PS();
		ZEnable = False;
		AlphaBlendEnable = False;
	}
}
