//-----------------------------------------------------------------------------
// |CgCg
//-----------------------------------------------------------------------------

float3 posPntLit;		// |CgCgW
float3 colPntLit;		// F
float AtteVal0;			// l
float AtteVal2;			// l ̂Q
float4 offsetPntLitUV;	// eNX`̃Y␳



struct VS_OUT_PointLight
{
	float4 Pos  : POSITION; 				// ˉeϊW
	float4 TPos : TEXCOORD0;
	float4 TexPos : TEXCOORD1;
};



// _VF[_
float4 PointLight_P0_VS( float4 Pos : POSITION ) : POSITION
{
	return mul( Pos, matWVP );
}

VS_OUT_PointLight PointLight_VS( float4 Pos : POSITION )
{
	VS_OUT_PointLight Out;
	Out.Pos = Out.TPos = mul( Pos, matWVP );
	Out.TexPos = mul( Pos, matWVPT ) + offsetPntLitUV;
	return Out;
}



// sNZVF[_
float4 PointLight_PS( float4 TPos : TEXCOORD0, float4 TexPos : TEXCOORD1 ) : COLOR
{
	float4 NmlDpt = tex2Dproj( nmldptSampler, TexPos );
	float3 Norm = normalize( 2.0f * NmlDpt.xyz - 1.0f );

	// eNX`ɋL^[xl烏[hWtZ
	float2 tmpPos = TPos.xy / TPos.w;
	float4 tmpVec4 = mul( float4( tmpPos.x, tmpPos.y, NmlDpt.w, 1.0 ), matInvVP );
	float3 posPix = tmpVec4.xyz / tmpVec4.w;

	// sNZ̍WƖ@|CgCg̓vZ
	float3 tmpVec = posPntLit - posPix;
	float distsq = dot( tmpVec, tmpVec );
	float coef = dot( Norm, normalize( tmpVec ) );

	float4 col = { colPntLit, 1.0f };		// Cg̐F
	col.xyz *= 1.0f / (AtteVal0 + distsq * AtteVal2) * coef;

	return col;
}



// eNjbN
technique PointLight
{
	pass P0
	{
		VertexShader = compile vs_2_0 PointLight_P0_VS();
		PixelShader = NULL;
		CullMode = faceWrong;		// ʕ\
		ZFunc = GREATEREQUAL;		// [xruȏv
		ZWriteEnable = False;		// [xlȂ
		ColorWriteEnable = 0;		// F`悵Ȃ
		StencilEnable = True;		// XeV}XNL
		StencilFail = KEEP;			// sAXeVlL[v
		StencilPass = INCR;			// AXeVlCNg
		StencilFunc = ALWAYS;		// ɃpX
	//	StencilRef = 1;
	//	StencilZFail = KEEP;		// XeVpXĐ[xeXgɎs
	}
	pass P1
	{
		VertexShader = compile vs_2_0 PointLight_VS();
		PixelShader = compile ps_2_0 PointLight_PS();
		CullMode = faceRight;		// \ʕ\
		ZFunc = LESSEQUAL;			// [xruȉv
	//	ZWriteEnable = False;
		ColorWriteEnable = RED|GREEN|BLUE|ALPHA;	// F`悷
	//	StencilEnable = True;
	//	StencilFail = ZERO;
		StencilPass = ZERO;
		StencilFunc = NOTEQUAL;
		StencilRef = 0;
	//	StencilZFail = ZERO;

//		BlendOp = ADD;				// i ADD	// ADD SUBTRACT REVSUBTRACT MIN MAX
		SrcBlend = SRCCOLOR;		// Z
		DestBlend = ONE;

//		BlendOp = REVSUBTRACT;		// Z ̒ƌZ̎ςKv
//		SrcBlend = ZERO;
//		DestBlend = INVSRCCOLOR;

//		SrcBlend = SRCALPHA;		// At@
//		DestBlend = INVSRCALPHA;	// At@

//		SrcBlend = ZERO;			// Z
//		DestBlend = SRCCOLOR;		//  Dest x Src  Src x Dest ł

//		SrcBlend = INVDESTCOLOR;	// XN[
//		DestBlend = ONE;

//		SrcBlend = INVDESTCOLOR;	// lK]
//		DestBlend = INVSRCCOLOR;

		// VF[_Őݒ肵̂D悳̂ŃXe[g̕ύXɂ͋CtKv
	}
}
/*
	̏ƒPɃCg̐FZ邾Ȃ̂ŁACeBOƂĂ͐ȂʂɂȂ
	|CgCgގ̉e󂯂悤ɂɂ
	ގRTeNX`ɏo͂āAɍKv
*/



// |CgCgp̃{[J̃jANbvʂɐڐGĂ鎞p̃eNjbN
technique PointLight2
{
	pass P0
	{
		VertexShader = compile vs_2_0 PointLight_VS();
		PixelShader = compile ps_2_0 PointLight_PS();
		CullMode = faceWrong;		// ʕ\
		ZFunc = GREATEREQUAL;		// [xruȏv
		ZWriteEnable = False;		// [xlȂ

		SrcBlend = SRCCOLOR;		// Z
		DestBlend = ONE;
	}
}


