//-----------------------------------------------------------------------------
// sNZVF[_ŗ֊s`
//-----------------------------------------------------------------------------

float PxEMapW;
float PxEMapH;
texture2D PixelEdgeMap;

sampler2D PixelEdgeSampler {
	Texture = <PixelEdgeMap>;
	AddressU = Clamp;
	AddressV = Clamp;
	MagFilter = Point;
	MinFilter = Point;
};

// ׂhsNZVF[_
float4 SolidColor_PS( PS_IN In ) : COLOR0
{
	float4 TexDif = tex2D( diffuseSampler, In.uv );
	float4 colDif = TexDif * Diffuse * In.color;
	return colDif;
}

struct VS_IN_PxE{
	float4	vPos	: POSITION;
	float2	vTex	: TEXCOORD0;
};

// _VF[_
VS_IN_PxE PixelEdge_VS( VS_IN_PxE In )
{
	VS_IN_PxE Out;
	Out.vPos = In.vPos;
	Out.vTex = In.vTex;
	return Out;
}

float4 PixelEdgeBrighten_PS( VS_IN_PxE In ) : COLOR0
{
	float offsetX = 1.0f / PxEMapW;
	float offsetY = 1.0f / PxEMapH;
	float4 TexC = tex2D( PixelEdgeSampler, In.vTex );
	float4 TexL = tex2D( PixelEdgeSampler, In.vTex + float2( -offsetX, 0.0f ) );	// 
	float4 TexR = tex2D( PixelEdgeSampler, In.vTex + float2(  offsetX, 0.0f ) );	// E
	float4 TexU = tex2D( PixelEdgeSampler, In.vTex + float2( 0.0f, -offsetY ) );	// 
	float4 TexD = tex2D( PixelEdgeSampler, In.vTex + float2( 0.0f,  offsetY ) );	// 
/*
	if( TexL.w < TexC.w || TexR.w < TexC.w || TexU.w < TexC.w || TexD.w < TexC.w ){
		TexC *= 2.5;	// ֊s𖾂邭
		TexC.w = 1.0;
	}
*/

	float x = 3 - step(TexC.w, TexL.w) - step(TexC.w, TexR.w) - step(TexC.w, TexU.w) - step(TexC.w, TexD.w);
	clip( x );
	TexC *= 2.5;	// ֊s𖾂邭
	TexC.w = 1.0;

	// ǂ낤H
	// ҂ clip ŕ`掩̂ȗłƂ

	return TexC;
}

float4 PixelEdgeDarken_PS( VS_IN_PxE In ) : COLOR0
{
	float offsetX = 1.0f / PxEMapW;
	float offsetY = 1.0f / PxEMapH;
	float4 TexC = tex2D( PixelEdgeSampler, In.vTex );
	float4 TexL = tex2D( PixelEdgeSampler, In.vTex + float2( -offsetX, 0.0f ) );	// 
	float4 TexR = tex2D( PixelEdgeSampler, In.vTex + float2(  offsetX, 0.0f ) );	// E
	float4 TexU = tex2D( PixelEdgeSampler, In.vTex + float2( 0.0f, -offsetY ) );	// 
	float4 TexD = tex2D( PixelEdgeSampler, In.vTex + float2( 0.0f,  offsetY ) );	// 
	float x = 3 - step(TexC.w, TexL.w) - step(TexC.w, TexR.w) - step(TexC.w, TexU.w) - step(TexC.w, TexD.w);
	clip( x );
	TexC *= 0.333333;	// ֊sÂ
	TexC.w = 1.0;
	return TexC;
}

// VGbg̕`
technique PixelEdge
{
	pass P0
	{
		VertexShader = compile vs_2_0 Diffuse_VS();
		PixelShader = compile ps_3_0 SolidColor_PS();
		CullMode = faceRight;
		StencilEnable = True;		// XeV}XNL
		StencilPass = INCR;			// AXeVlCNg
		StencilFunc = ALWAYS;		// ɃpX

	//	SrcBlend = SRCCOLOR;		// At@ƓhԂ
	//	DestBlend = ZERO;
	}
}

// VGbg֊s`
// ֊s𖾂邭
technique PixelEdgeBrighten
{
	pass P0
	{
		VertexShader = compile vs_2_0 PixelEdge_VS();
		PixelShader = compile ps_3_0 PixelEdgeBrighten_PS();
		CullMode = CCW;
		StencilPass = ZERO;
		StencilFunc = NOTEQUAL;
		StencilRef = 0;
	}
}

// VGbg֊s`
// ֊sÂ
technique PixelEdgeDarken
{
	pass P0
	{
		VertexShader = compile vs_2_0 PixelEdge_VS();
		PixelShader = compile ps_3_0 PixelEdgeDarken_PS();
		CullMode = CCW;
		StencilPass = ZERO;
		StencilFunc = NOTEQUAL;
		StencilRef = 0;
	}
}


